// AUTOMGEN interpretor runtime	 - I/O
// Target specific file : physicals inputs/outputs
// (C) 2003-2008 IRAI

#define BYTE unsigned char
#define WORD unsigned short
#define DWORD unsigned long

#define _USE_MATH_DEFINES
#include <cmath>
#include <iostream>

#include "core.h"
#include "stdlib.h"
#include "stdio.h"
#include "pigpio.h"




// Initialize I/I
int initio(void)
{
if (gpioInitialise() < 0)
	{
	printf("gpioInitialise failed\n");
	return -1;
	}
printf("gpioInitialise ok\n");
	
// user gpio 0-1, 4, 7-11, 14-15, 17-18, 21-25.
// set 0-1, 4, 7-11, 14 for 9 inputs
// set 15, 17-18, 21-25 for 8 outputs

gpioSetMode(0, PI_INPUT); 	
gpioSetMode(1, PI_INPUT); 	
gpioSetMode(4, PI_INPUT); 	
gpioSetMode(7, PI_INPUT); 	
gpioSetMode(8, PI_INPUT); 	
gpioSetMode(9, PI_INPUT); 	
gpioSetMode(10, PI_INPUT); 	
gpioSetMode(11, PI_INPUT); 	
gpioSetMode(14, PI_INPUT); 	

gpioSetMode(15, PI_OUTPUT); 	
gpioSetMode(17, PI_OUTPUT); 	
gpioSetMode(18, PI_OUTPUT); 	
gpioSetMode(21, PI_OUTPUT); 	
gpioSetMode(22, PI_OUTPUT); 	
gpioSetMode(23, PI_OUTPUT); 	
gpioSetMode(24, PI_OUTPUT); 	
gpioSetMode(25, PI_OUTPUT); 	
printf("I/o setmodes ok\n");
return 0;
}

// Close I/O
int uninitio(void)
{
gpioTerminate();
return 0;
}

// Read inputs
int readi(struct _a7int *a7int)
{
setvar(a7int,0,0,gpioRead(0),-1);
setvar(a7int,0,1,gpioRead(1),-1);
setvar(a7int,0,2,gpioRead(4),-1);
setvar(a7int,0,3,gpioRead(7),-1);
setvar(a7int,0,4,gpioRead(8),-1);
setvar(a7int,0,5,gpioRead(9),-1);
setvar(a7int,0,6,gpioRead(10),-1);
setvar(a7int,0,7,gpioRead(11),-1);
setvar(a7int,0,8,gpioRead(14),-1);
return 0;
}

// Write outputs
int writeo(struct _a7int *a7int)
{
gpioWrite(15,(a7int->pO[0]&0x40)?1:0);	
gpioWrite(17,(a7int->pO[1]&0x40)?1:0);	
gpioWrite(18,(a7int->pO[2]&0x40)?1:0);	
gpioWrite(21,(a7int->pO[3]&0x40)?1:0);	
gpioWrite(22,(a7int->pO[4]&0x40)?1:0);	
gpioWrite(23,(a7int->pO[5]&0x40)?1:0);	
gpioWrite(24,(a7int->pO[6]&0x40)?1:0);	
gpioWrite(25,(a7int->pO[7]&0x40)?1:0);	
return 0;
}
