// AUTOMGEN interpretor runtime	 - communication serial and TCP_IP
// (C) 2003-2008 IRAI

#include "stdlib.h"
#include "stdio.h"
#include "memory.h"
#include "string.h"
#include "unistd.h"

#define BOOL int
#define TRUE 1                            
#define FALSE 0
#define BYTE unsigned char
#define WORD unsigned short
#define DWORD unsigned long

#include "core.h"
#include "com.h"
#include "target.h"

                                                            
unsigned char slavenumber=SLAVENUMBER; 

unsigned long lasttimetimout;


// Timeout process
void inittimout(void)
{
lasttimetimout=target_gettimeinms();
}

int istimout(void)
{
return (target_gettimeinms()-lasttimetimout>=TIMEOUT)?1:0;
}

unsigned curtcpclient;
unsigned short _tcpipport=TCPIPPORT;
unsigned _com=TCPIP;
unsigned long _baudrate=_BAUDRATE;
unsigned _parity=_PARITY;
unsigned _stopbit=_STOPBIT;

// Send 
void sendtrame(unsigned char *data,unsigned len)
{
unsigned char crc;
unsigned count;
unsigned char buff[MAXTRAMEOUT];
unsigned pos=0;
crc='Z'+slavenumber+(unsigned char)(len&0xff)+(unsigned char)(len>>8);
buff[pos++]='Z';
buff[pos++]=slavenumber;
buff[pos++]=(unsigned char)(len&0xff);
buff[pos++]=(unsigned char)(len>>8);
for(count=0;count<len;count++)
    {
    buff[pos++]=data[count];
    crc+=data[count];
	}
buff[pos++]=(unsigned char )(~crc);
if(_com==TCPIP)
	{
	target_netcom_srvsenddata(curtcpclient,buff,pos);
	}
else
	{
	target_com_send(buff,pos);
	}
}


// RX buffer
unsigned ltramein;
unsigned char tramein[MAXTRAMEIN+256];

void com_no(void)
{
sendtrame((unsigned char *)"\xFF",1);
}

void com_no2(void)
{
sendtrame((unsigned char *)"\xFE",1);
}

void com_ok(void)
{
sendtrame((unsigned char *)"\x00",1);
}


// Process in buffer
void processtrame(struct _a7int *a7int)
{
// For program download
static unsigned char progname[13];
static char fname[256];
static unsigned long proglen;
static unsigned long flen;
static BOOL downloadprog=FALSE;
static BOOL downloadfile=FALSE;
static char filename[512]="",*p;
if(ltramein>0)
    {
    switch(tramein[0]) // Function code
        {
		case 0 : // Connection test
            {
            if(ltramein==1)
                {
				unsigned char data[32];
				unsigned maxbloclen=MAXTRAMEIN-128;
				data[0]=0;
				if(_com!=TCPIP)
					{
					maxbloclen=256;
					}
				*((WORD *)(&data[1]))=maxbloclen;
	            data[3]=target_confbyte();
				memcpy(&data[4],target_id(),16);
				sendtrame(data,20); // Ok, len must be 20 and not 19, corrected 10/23/2008
                }
            else
                {
                com_no();
                }
            } break;
        case 1 : // Select mode RUN/STOP/INIT/STEP
            {
            if(ltramein!=2)
                {
                com_no(); // NO
                }
            else
                {
                switch(tramein[1]) // Mode
                    {
                    case 0 : // stop
                        {
                        if(a7int->run)
							{
							a7int->run=0;
							com_ok(); // Ok
							}
						else
							{
							com_no2(); // NO
							}
						} break;
					case 1 : // run
						{
						if(!a7int->run)
							{
							a7int->run=1;
							com_ok(); // Ok
							}
						else
							{
							com_no2(); // NO
							}
						} break;
					case 2 : // step
						{
						if(!a7int->run)
							{
							a7int->step=1;
							com_ok(); // Ok
							}
						else
							{
							com_no2(); // NO
							}
						} break;
					case 3 : // init
                        {
						a7int->init=1;
                        com_ok(); // Ok
                        } break;
                    case 0x80 : // read RUN/STOP
                        {
                        sendtrame(a7int->run?(unsigned char *)"\x00\x01":(unsigned char *)"\x00\x00",2); 
                        } break;
					default :
						{
						com_no(); // NO
						}
					}
				}
			} break;
		case 2 : // Read one or more variable states
			{
			unsigned char data[1025];
			unsigned first,len;
			unsigned count;
			int checkforce=0;
			if(ltramein!=6)
				{
				com_no(); // NO
				break;
				}
            first=tramein[2]+(tramein[3]<<8);
            len=tramein[4]+(tramein[5]<<8);
            if(tramein[1]&0x80)
				{
				checkforce=1;
				tramein[1]&=0x7f;
				}
			switch(tramein[1]) // Type
                {
                case 0 : // I
                    {
                    unsigned pos=0,bpos=0;
					if(len+first>a7int->ni||(len+7)/8>1024)
                        {
						com_no(); // NO
                        break;
                        }
                    memset(data,0,1025);
                    for(count=0;count<len;count++)
                        {
                        if(a7int->pI[count+first]&0x20) data[1+pos]|=1<<bpos;
						bpos++;
						if(bpos==8)
							{
							pos++;
							bpos=0;
							}
						if(checkforce)
							{
				            if(isforced(a7int,tramein[1],(WORD)(first+count))) data[1+pos]|=1<<bpos;
							bpos++;
							if(bpos==8)
								{
								pos++;
								bpos=0;
								}
					        }
                        }
					sendtrame(data,2+pos);
                    } break;
                case 1 : // O
					{
                    unsigned pos=0,bpos=0;
					if(len+first>a7int->no||(len+7)/8>1024)
                        {
						com_no(); // NO
                        break;
                        }
                    memset(data,0,1025);
                    for(count=0;count<len;count++)
                        {
                        if(a7int->pO[count+first]&0x20) data[1+pos]|=1<<bpos;
						bpos++;
						if(bpos==8)
							{
							pos++;
							bpos=0;
							}
						if(checkforce)
							{
				            if(isforced(a7int,tramein[1],(WORD)(first+count))) data[1+pos]|=1<<bpos;
							bpos++;
							if(bpos==8)
								{
								pos++;
								bpos=0;
								}
					        }
                        }
					sendtrame(data,2+pos);
                    } break;
                case 2 : // B
                    {
                    unsigned pos=0,bpos=0;
                    if(len+first>a7int->nb||(len+7)/8>1024)
                        {
						com_no(); // NO
                        break;
                        }
                    memset(data,0,1025);
                    for(count=0;count<len;count++)
                        {
                        if(a7int->pB[count+first]&0x20) data[1+pos]|=1<<bpos;
						bpos++;
						if(bpos==8)
							{
							pos++;
							bpos=0;
							}
						if(checkforce)
							{
				            if(isforced(a7int,tramein[1],(WORD)(first+count))) data[1+pos]|=1<<bpos;
							bpos++;
							if(bpos==8)
								{
								pos++;
								bpos=0;
								}
					        }
                        }
					sendtrame(data,2+pos);
                    } break;
                case 3 : // T counter
                    {
					DWORD *ps,*pt;
					if(len+first>a7int->nt||len*sizeof(unsigned long)>1024)
                        {
                        com_no(); // NO
						break;
                        }
                    data[0]=0;
					ps=(DWORD *)&a7int->pT[sizeof(unsigned long)+first*sizeof(unsigned long)*2];
					pt=(DWORD *)&data[1];
					for(count=0;count<len;count++)
						{
						memcpy(pt,ps,sizeof(DWORD));
						pt++;
						ps+=2;
						}
					sendtrame(data,1+len*sizeof(unsigned long));
                    } break;
                case 4 : // C
                    {
                    if(len+first>a7int->nc||len*sizeof(unsigned long)>1024)
                        {
                        com_no(); // NO
						break;
                        }
                    data[0]=0;
					memcpy(&data[1],&a7int->pC[first],len*sizeof(unsigned short));
					sendtrame(data,1+len*sizeof(unsigned short));
                    } break;
                case 5 : // M
                    {
                    if(len+first>a7int->nm||len*sizeof(unsigned long)>1024)
                        {
                        com_no(); // NO
						break;
                        }
                    data[0]=0;
					memcpy(&data[1],&a7int->pM[first],len*sizeof(unsigned short));
					sendtrame(data,1+len*sizeof(unsigned short));
                    } break;
                case 6 : // F
                    {
                    if(len+first>a7int->nf||len*sizeof(float)>1024)
                        {
                        com_no(); // NO
                        break;
                        }
                    data[0]=0;
					memcpy(&data[1],&a7int->pF[first],len*sizeof(float));
                    sendtrame(data,1+len*sizeof(float));
                    } break;
				case 7 : // L
                    {
                    if(len+first>a7int->nl||len*sizeof(unsigned long)>1024)
                        {
						com_no(); // NO
                        break;
                        }
                    data[0]=0;
                    memcpy(&data[1],&a7int->pL[first],len*sizeof(unsigned long));
                    sendtrame(data,1+len*sizeof(unsigned long));
                    } break;
                case 8 : // T preset
                    {
					DWORD *pt,*ps;
                    if(len+first>a7int->nt||len*sizeof(unsigned long)>1024)
                        {
                        com_no(); // NO
						break;
                        }
                    data[0]=0;
					ps=(DWORD *)&a7int->pT[first*sizeof(unsigned long)*2];

 					pt=(DWORD *)&data[1];
					for(count=0;count<len;count++)
						{
						memcpy(pt,ps,sizeof(DWORD));
						pt++;
						ps+=2;
						}
 					pt=(DWORD *)&data[1];
              //printf("%2.2X,%2.2X,%2.2X,%2.2X\n",data[1],data[2],data[3],data[4]);
					sendtrame(data,1+len*sizeof(unsigned long));
                    } break;
                default :
                    {
                    com_no(); // NO
                    }
                }
			} break;
		case 3 : // Write one variable state
			{
			unsigned num;
			num=tramein[2]+(tramein[3]<<8);
 			if(downloadprog)
				{
            unsigned long data;
				// predispositions writing
 				switch(tramein[1])
					{
					case 3 : memcpy(&data,&tramein[4],4); break;
					case 4 : memcpy(&data,&tramein[4],2); break;
					case 5 : memcpy(&data,&tramein[4],2); break;
					case 6 : memcpy(&data,&tramein[4],4); break;
					case 7 : memcpy(&data,&tramein[4],4); break;
					}
				switch(tramein[1])
					{
					case 3 :
					case 4 :
					case 5 :
					case 6 :
					case 7 :
						{
						if(target_prd_save(tramein[1],(unsigned short)num,data)<0)
                  			{
							com_no(); // NO
							return;
							}
						} break;
					}
				}
			switch(tramein[1]) // Type
				{
				case 0 : // I
					{
					if(ltramein!=5||num>=a7int->ni)
						{
						com_no(); // NO
						break;
						}
					setvar(a7int,0,num,tramein[4],(unsigned)-1);
					com_ok(); // Ok
					} break;
				case 1 : // O
					{
					if(ltramein!=5||num>=a7int->no)
						{
						com_no(); // NO
						break;
                        }
					setvar(a7int,1,num,tramein[4],(unsigned)-1);
                    com_ok(); // Ok
                    } break;
                case 2 : // B
                    {
                    if(ltramein!=5||num>=a7int->nb)
                        {
                        com_no(); // NO
                        break;
						}
					setvar(a7int,2,num,tramein[4],(unsigned)-1);
					com_ok(); // Ok
                    } break;
                case 3 : // T preset
					{
                    if(ltramein!=8||num>=a7int->nt)
                        {
                        com_no(); // NO
                        break;
						}
					memcpy(&a7int->pT[num*sizeof(unsigned long)*2],&tramein[4],sizeof(unsigned long));
					com_ok(); // Ok
					} break;
                case 4 : // C
					{
                    if(ltramein!=6||num>=a7int->nc)
                        {
                        com_no(); // NO
                        break;
						}
					memcpy(&a7int->pC[num],&tramein[4],sizeof(unsigned short));
					com_ok(); // Ok
					} break;
                case 5 : // M
					{
                    if(ltramein!=6||num>=a7int->nm)
                        {
                        com_no(); // NO
                        break;
						}
					memcpy(&a7int->pM[num],&tramein[4],sizeof(unsigned short));
					com_ok(); // Ok
					} break;
				case 6 : // F
					{
					if(ltramein!=8||num>=a7int->nf)
						{
						com_no(); // NO
						break;
						}
					memcpy(&a7int->pF[num],&tramein[4],sizeof(float));
					com_ok(); // Ok
					} break;
				case 7 : // L
					{
					if(ltramein!=8||num>=a7int->nl)
						{
						com_no(); // NO
						break;
						}
					memcpy(&a7int->pL[num],&tramein[4],sizeof(unsigned long));
					com_ok(); // Ok
					} break;
				default :
					{
					com_no(); // NO
					}
				}
			} break;
		case 4 : // Begining of program download
			{
			if(ltramein<6||ltramein>17)
				{
				com_no(); // NO
				break;
				}
			memcpy(&proglen,&tramein[1],4);
			memcpy(&progname,&tramein[5],ltramein-5);
			progname[ltramein-5]=0;
         if(target_prog_exist()) target_prog_delete();
			if(a7int->progmem!=NULL)
                {
					free(a7int->progmem);
					a7int->progmem=NULL;
                }
			a7int->progmem=(unsigned char*)malloc(proglen);
	     if(a7int->progmem==NULL)
         	{
				com_no(); // NO
				break;
            }
	       a7int->proglen=proglen;
			com_ok(); // OK
			downloadprog=TRUE;
			} break;
		case 5 : // Program block download
			{
			unsigned long pos,len;
			memcpy(&pos,&tramein[1],4);
			memcpy(&len,&tramein[5],4);
			if(!downloadprog||pos+len>proglen)
				{
				com_no(); // NO
				break;
				}
			memcpy(&a7int->progmem[pos],&tramein[9],(unsigned)len);
			com_ok(); // OK
			} break;
		case 6 : // End of download
			{
			if(!downloadprog||ltramein<6||ltramein>17)
				{
				com_no(); // NO
				break;
				}
			if(memcmp(&proglen,&tramein[1],4)!=0||memcmp(&progname,&tramein[5],ltramein-5)!=0)
				{
	            downloadprog=FALSE;
				com_no2(); // erreur
				break;
				}
			a7int->init=1;
         if(target_prog_save(a7int)==0)
         	{
				com_ok(); // OK
            }
			else
         	{
            com_no();
            }
         downloadprog=FALSE;
			} break;
        case 7 : // Begining of program compare
            {
            if(ltramein<6||ltramein>17)
				{
                com_no(); // NO
                break;
                }
            memcpy(&proglen,&tramein[1],4);
            memcpy(&progname,&tramein[5],ltramein-5);
            progname[ltramein-5]=0;
            com_ok(); // OK
            } break;
        case 8 : // Compare one program block
            {
			unsigned long pos,len;
			if(ltramein!=9)
				{
				com_no(); // NO
				break;
				}
			memcpy(&pos,&tramein[1],4);
			memcpy(&len,&tramein[5],4);
			if(pos+len>proglen)
				{
				com_no(); // NO
				break;
				}
			memcpy(&tramein[1],&a7int->progmem[pos],len);
			tramein[0]=0;
			sendtrame(tramein,(unsigned)len+1); // OK
			} break;
		case 9 : // End of program compare
            {
            if(ltramein<6||ltramein>17)
                {
                com_no(); // NO
                break;
                }
			if(memcmp(&proglen,&tramein[1],4)!=0||memcmp(&progname,&tramein[5],ltramein-5)!=0)
				{
				com_no2(); // error
				break;
				}
			if(memcmp(&proglen,&tramein[1],4)!=0||memcmp(&progname,&tramein[5],ltramein-5)!=0)
				{
                com_no2(); // error
                break;
                }
            com_ok(); // OK
            } break;
		case 128 : // Begining of file download
			{
			strcpy(filename,target_getfiledirectory());
			if(ltramein<6||ltramein>512+5)
				{
                com_no(); // NO
				break;
				}
			memcpy(&flen,&tramein[1],4);
			memcpy(&fname,&tramein[5],ltramein-5);
			fname[ltramein-5]=0;
			strcat(filename,fname);
			unlink(filename);
            com_ok(); // OK
			downloadfile=TRUE;
			} break;
		case 129 : // File block download
			{
			FILE *f;
			unsigned long pos,len;
			memcpy(&pos,&tramein[1],4);
			memcpy(&len,&tramein[5],4);
			if(!downloadfile||pos+len>flen)
				{
                com_no(); // NO
				break;
				}
			f=fopen(filename,"ab");
			if(!f)
				{
				downloadfile=FALSE;
                com_no(); // NO
				break;
				}
			if(fseek(f,pos,0)!=0||fwrite(&tramein[9],len,1,f)!=1)
				{
				fclose(f);
				downloadfile=FALSE;
                com_no(); // NO
				break;
				}
			fclose(f);
            com_ok(); // OK
			} break;
		case 130 : // End of file download
			{
			if(!downloadfile)
				{
                com_no(); // NO
				break;
				}
            com_ok(); // OK
            downloadfile=FALSE;
			} break;
		case 131: // Restart SCADA
			{
			if(target_restartscada()==0)
				{
	            com_ok(); // OK
				}
			else
				{
	            com_ok(); // OK
				}
			} break;
		case 132: // Delete SCADA files
			{
			if(target_deletescadafiles()==0)
				{
	            com_ok(); // OK
				}
			else
				{
	            com_ok(); // OK
				}
			} break;

        default :
            {
            com_no(); // NO
            }
        }
    }
}



// Initialisation
int initcom(void)
{
if(_com==TCPIP)
	{
	if(target_netcom_start()<0)
		{
		return -1;
		}
	if(target_netcom_srvopen(NULL,(WORD)_tcpipport)<0)
		{
		return -2;
		}
	}
else
	{
	if(target_com_open(_com,_baudrate,_parity,8,_stopbit)!=0)
		{
		return -1; // error
		}
	}

return 0;
}

int uninitcom(void)
{
if(_com==TCPIP)
	{
	target_netcom_srvclose();
	target_netcom_close();
	}
else	
	{
	target_com_close();
	}
return 0;
}


int ischar(void)
{
if(_com==TCPIP)
	{
	if(target_netcom_srvgetlenin(curtcpclient)>0) return 1;
	return 0;
	}
return target_com_ischarin();
}

int getcom(void)
{
if(_com==TCPIP)
	{
	int c=0;
	if(target_netcom_srvread(curtcpclient,(unsigned char *)&c,1)==1)
		{
		return c;
		}
	return -1;
	}
return target_com_getchar();
}



// Requests processing
void _process(struct _a7int *a7int)
{
static unsigned phase;
static unsigned len;
static unsigned char crc;
static unsigned char slave;
do
    {
    switch(phase)
        {
        case 0 : // Wait header char
            {
            if(ischar()) //
                {
                if(getcom()=='Z') // Header char?
                    {
                    phase++; // Yes
                    }
                else
                    {
                    return;
                    }
                }
            else
                {
                return;
                }
            crc='Z';
            inittimout();
            }
		case 1 : // Wait slave number
			{
            if(ischar())
                {
                slave=getcom();
                crc+=slave;
                phase++;
                }
            else
                {
                if(istimout())
                    {
                    phase=0;
                    }
                return;
                }
            inittimout();
			}
		case 2 : // Wait LSB length
            {
            if(ischar())
                {
                len=getcom();
                crc+=len;
                phase++;
                }
            else
                {
                if(istimout())
                    {
                    phase=0;
                    }
                return;
                }
            inittimout();
            }
        case 3 : // Wait MSB length
            {
            if(ischar())
                {
                len|=(unsigned)getcom()<<8;
                crc+=(len>>8);
                ltramein=0;
                phase++;
                }
            else
                {
                if(istimout())
                    {
                    phase=0;
                    }
                return;
                }
            inittimout();
            }
        case 4 : // Wait DATAs
            {
            int skip=0;
            #ifndef _WIN32
			if(_com==TCPIP)
            	{ // Optimizing reading of large size datas (already in Ethernet buffer)
               if(target_netcom_srvgetlenin(curtcpclient)>=(int)len)
               	{
                  unsigned count;
                  target_netcom_srvread(curtcpclient,&tramein[ltramein],len);
                  for(count=ltramein;count<len;count++)
                  	{
                		crc+=tramein[ltramein+count];
                  	}
                  //printf("optimized !");
                  ltramein+=len;
            		inittimout();
		            if(ltramein==len) phase++;
                  }
               else
               	{
                	if(istimout())
                    	{
                    	phase=0;
                    	}
                  }
               break;
               }
            //if(!skip)
            #endif
				{
               if(ischar())
               	{
                	tramein[ltramein]=getcom();
                	crc+=tramein[ltramein++];
                	}
            	else
                	{
                	if(istimout())
                    	{
                    	phase=0;
                    	}
                	return;
                	}
            	}
            inittimout();
            if(ltramein==len) phase++;
            else break;
            }
        case 5 : // Wait crc
            {
            if(ischar())
                {
                int charin;
                charin=getcom();
                if((unsigned char)~crc==(unsigned char)charin)
                    { // CRC ok
					if(slave==slavenumber||slave==0xff)
						{ // Slave = this slave
	                    processtrame(a7int);
						}
                    }
                phase=0;
                }
            else
				{
				if(istimout())
					{
					phase=0;
					}
				return;
				}
			}
		}
	}
while(1);
}

unsigned ncliconnected;

void processcom(struct _a7int *a7int)
{
if(_com==TCPIP)
	{
	int client,n=0;
	client=target_netcom_srvgetfirstclient();
	while(client!=-1)
		{
		n++;
		curtcpclient=(unsigned)client;
		_process(a7int);
		client=target_netcom_srvgetnextclient(client);
		}
	ncliconnected=n;
	}
else
	{
	_process(a7int);
	}
}
