// AUTOMGEN interpretor runtime	 - core
// (C) 2003-2008 IRAI

#include "memory.h"
#include "stdlib.h"
#include "math.h"

#define BYTE unsigned char
#define WORD unsigned short
#define DWORD unsigned long

#include "core.h"
#include "target.h"
#include "com.h"

// Internal boolean tables
unsigned char *booltable1[BOOLTABLELEN];
unsigned booltable1len=0;
unsigned char *booltable2[BOOLTABLELEN];
unsigned booltable2len=0;
char boolvarselector;
// Sub routines calls stack
unsigned char *srstack[SRSTACKLEN];
unsigned srstackpos=0;


// Set a boolean varariable state
void setvar(struct _a7int *a7int,unsigned type,unsigned long num,int state,unsigned pos)
{
unsigned char *pVar,**pVar2;
unsigned count;
#ifndef NOFORCE
if(pos==(unsigned)-1)
	{ // System request
	if(state>=3&&state<=5)
		{
		int force;
		switch(state)
			{
			case 3 : force=1; break;
			case 4 : force=0; break;
			case 5 : force=2; break;
			}
		setforce(a7int,(BYTE)type,(WORD)num,force);
		return;
		}
	}
#endif
switch(type)
	{
	case 0 : pVar=&a7int->pI[num]; break;
	case 1 : pVar=&a7int->pO[num]; break;
	case 2 : pVar=&a7int->pB[num]; break;
	case 3 : pVar=&a7int->pT[(2*sizeof(unsigned long)*a7int->nt)+num]; break;
	case 4 :
		{
		unsigned short *pWord;
		pWord=&a7int->pC[num];
		switch(state)
			{
			case 0 : *pWord=0; break;
			case 1 : *pWord=0xffff; break;
			case 2 : *pWord^=0xffff; break;
			}
		return;
		}
	case 5 :
		{
		unsigned short *pWord;
		pWord=&a7int->pM[num];
		switch(state)
			{
			case 0 : *pWord=0; break;
			case 1 : *pWord=0xffff; break;
			case 2 : *pWord^=0xffff; break;
			}
		return;
		}
	case 7 :
		{
		unsigned long *pDWord;
		pDWord=&a7int->pL[num];
		switch(state)
			{
			case 0 : *pDWord=0; break;
			case 1 : *pDWord=0xffffffff; break;
			case 2 : *pDWord^=0xffffffff; break;
			}
		return;
		}
	default : 
		{
		#ifdef _SECURE
		a7int->pB[SYSTEM_BIT_FAULT]=TRUEFORBOOL; 
		a7int->pB[SYSTEM_BIT_EMERGENCY_STOP]=TRUEFORBOOL; 
		a7int->pL[SYSTEM_WORD_ERROR_POSITION]=pos;
		a7int->pM[SYSTEM_WORD_ERROR_NUMBER]=AUTOMGEN_ERR_ILLEGALACTIONBOOLVAR;
		target_fatal();
		#endif
		return;
		}
	}
switch(state)
	{
	case 0 : // reset
		{
		if(!(*pVar&0x10)) return; // Already false
		*pVar&=~0x10;
		} break;
	case 1 : // set
		{
		if(*pVar&0x10) return; // Already true
		*pVar|=0x10;
		} break;
	case 2 : // Inversion
		{
		*pVar^=0x10;
		} break;
	default :
		{
		#ifdef _SECURE
		a7int->pB[SYSTEM_BIT_FAULT]=TRUEFORBOOL;  
		a7int->pB[SYSTEM_BIT_EMERGENCY_STOP]=TRUEFORBOOL; 
		a7int->pL[SYSTEM_WORD_ERROR_POSITION]=pos;
		a7int->pM[SYSTEM_WORD_ERROR_NUMBER]=AUTOMGEN_ERR_ILLEGALACTIONBOOLSET;
		target_fatal();
		#endif
		return;
		}
	}
// If already in table #2, remove frome table #2
if(!boolvarselector)
	{
	pVar2=booltable2;
	for(count=0;count<booltable2len;count++)
		{
		if(pVar==*pVar2)
			{
			*pVar2=(unsigned char *)(void *)-1; // Cancel this item
			break;
			}
		pVar2++;
		}
	// Add item to table #1
	if(booltable1len==BOOLTABLELEN)
		{
		a7int->pB[SYSTEM_BIT_INTERNAL_TABLE_OVERFLOW]=TRUEFORBOOL;  // Table overflow
		a7int->pB[SYSTEM_BIT_EMERGENCY_STOP]=TRUEFORBOOL; 
		a7int->pL[SYSTEM_WORD_ERROR_POSITION]=pos;
		a7int->pM[SYSTEM_WORD_ERROR_NUMBER]=AUTOMGEN_ERR_BOOLTABLEFULL;
		target_fatal();
		return;
		}
	booltable1[booltable1len++]=pVar;
	}
else
	{
	pVar2=booltable1;
	for(count=0;count<booltable1len;count++)
		{
		if(pVar==*pVar2)
			{
			*pVar2=(unsigned char *)(void *)-1; // Cancel this item
			break;
			}
		pVar2++;
		}
	// Add item to table #1
	if(booltable2len==BOOLTABLELEN)
		{
		// Table overflow
		a7int->pB[SYSTEM_BIT_INTERNAL_TABLE_OVERFLOW]=TRUEFORBOOL;  
		a7int->pB[SYSTEM_BIT_EMERGENCY_STOP]=TRUEFORBOOL; 
		a7int->pL[SYSTEM_WORD_ERROR_POSITION]=pos;
		a7int->pM[SYSTEM_WORD_ERROR_NUMBER]=AUTOMGEN_ERR_BOOLTABLEFULL;
		target_fatal();
		return;
		}
	booltable2[booltable2len++]=pVar;
	}
}

#ifndef NOFORCE




// Process forcing
void processforce(struct _a7int *a7int)
{
// BIT #39            :     FORCING ENABLE
// BITS #40 to 55     :     FORCING STATE
// LES MOTS 146 � 161 :     VARIABLE TYPE AND NUMBER

// BIT 15 14 13 12 11 10 9 8 7 6 5 4 3 2 1 0
//      !  ! \____________  _______________/
//      !  !              \/
//      !  !              #
//      0  0     NONE
//      0  1     I
//      1  0     O
//      1  1     B
unsigned count;
if(!(a7int->pB[39]&0x20))
	{
	return;
	}
for(count=0;count<16;count++)
	{
	unsigned short wforce;
	int state;
	wforce=a7int->pM[146+count];
	state=a7int->pB[40+count]&0x20?1:0;
	switch(wforce>>14)
		{
		case 0 : // none
			{
			break;
			} 
		case 1 : // I
			{
			setvar(a7int,0,wforce&0x3fff,state,0xffffffff);
			} break;
		case 2 : // O
			{
			setvar(a7int,1,wforce&0x3fff,state,0xffffffff);
			} break;
		case 3 : // B
			{
			setvar(a7int,2,wforce&0x3fff,state,0xffffffff);
			} break;
		}
	}
}

// Test the forcing state of a variable, return : 0=not forced, 0x80=forced to false, x81=forced to 1
int isforced(struct _a7int *a7int,BYTE type,WORD wNum)
{
BYTE	*pBit;
WORD	*pMot;
unsigned count;
pBit=a7int->pB;
if(!(pBit[39]&0x20)) return 0;
for(count=0;count<16;count++)
	{
	pMot=&a7int->pM[146+count];
	if(type==0&&((*pMot)&0xc000)==0x4000&&((*pMot)&0x3fff)==wNum)
		{
		return (pBit[40+count]&0x40)?0x80:0x81;
		}
	if(type==1&&((*pMot)&0xc000)==0x8000&&((*pMot)&0x3fff)==wNum)
		{
		return (pBit[40+count]&0x40)?0x80:0x81;
		}
	if(type==2&&((*pMot)&0xc000)==0xc000&&((*pMot)&0x3fff)==wNum)
		{
		return (pBit[40+count]&0x40)?0x80:0x81;
		}
	} 
return 0;
}

// Define the forcing state of a variable
int setforce(struct _a7int *a7int,BYTE type,WORD wNum,int force)
{
BYTE	*pBit;
WORD	*pMot;
unsigned count;
pBit=a7int->pB;
pMot=a7int->pM;
if(force==0||force==1) // Add a forcing
	{
	if(pBit[39]&0x20)
		{
		// Search for a free position or a forcing on the same variable
		for(count=0;count<16;count++)
			{
			if((pMot[146+count]&0xc000)==0
			||type==0&&(pMot[146+count]&0x4000)==0x4000&&(pMot[146+count]&0x3fff)==wNum
			||type==1&&(pMot[146+count]&0x8000)==0x8000&&(pMot[146+count]&0x3fff)==wNum
			||type==2&&(pMot[146+count]&0xc000)==0xc000&&(pMot[146+count]&0x3fff)==wNum
			) // Void place
				{
				switch(type)
					{
					case 0 : pMot[146+count]=0x4000|wNum; break;
					case 1 : pMot[146+count]=0x8000|wNum; break;
					case 2 : pMot[146+count]=0xc000|wNum; break;
					}
				pBit[40+count]=force?TRUEFORBOOL:0;
				return 0;
				}
			}
		return -2; // Forcing table full
		}
	else
		{
		for(count=0;count<16;count++) // Forcing table reset
			{
			pMot[count+146]=0;
			}
		switch(type)
			{
			case 0 : pMot[146]=0x4000|wNum; break;
			case 1 : pMot[146]=0x8000|wNum; break;
			case 2 : pMot[146]=0xc000|wNum; break;
			}
		pBit[40]=force?TRUEFORBOOL:0;
		pBit[39]=TRUEFORBOOL; // Enable forcing
		}
	return 0;
	}
if(force==2)
	{
	// Forcing cancelation
	// Search for the variable
	if(pBit[39]&0x20)
		{
		for(count=0;count<16;count++)
			{
			if(type==0&&(pMot[146+count]&0xc000)==0x4000&&(pMot[146+count]&0x3fff)==wNum) 
				{
				pMot[146+count]=0;
				}
			if(type==1&&(pMot[146+count]&0xc000)==0x8000&&(pMot[146+count]&0x3fff)==wNum) 
				{
				pMot[146+count]=0;
				}
			if(type==2&&(pMot[146+count]&0xc000)==0xc000&&(pMot[146+count]&0x3fff)==wNum) 
				{
				pMot[146+count]=0;
				}
			}
		// No more forcing: reset b39
		for(count=0;count<16;count++)	
			{
			if(pMot[146+count]&0xc000) return 0;
			}
		pBit[39]=0;
		}
	}
return 0;
}



#endif

// Process boolean variable states
void updatebool(struct _a7int *a7int)
{
unsigned count;
BYTE *pVar;
unsigned char v;
if(!boolvarselector) // To avoid copying tables, change the processing order each cycle
	{
	// Process table #2
	for(count=0;count<booltable2len;count++)
		{
		pVar=booltable2[count];
		if(pVar!=(void *)-1)
			{
			v=*pVar;
			*pVar=(v&0x10)|(v<<1);
			}
		}
	booltable2len=0;
	// Process table #1
	for(count=0;count<booltable1len;count++)
		{
		pVar=booltable1[count];
		v=*pVar;
		*pVar=(v&0x10)|(v<<1);
		}
	boolvarselector=1;
	}
else
	{
	// Process table #1
	for(count=0;count<booltable1len;count++)
		{
		pVar=booltable1[count];
		if(pVar!=(void *)-1)
			{
			v=*pVar;
			*pVar=(v&0x10)|(v<<1);
			}
		}
	booltable1len=0;
	// Process table #1
	for(count=0;count<booltable2len;count++)
		{
		pVar=booltable2[count];
		v=*pVar;
		*pVar=(v&0x10)|(v<<1);
		}
	boolvarselector=0;
	}
}

// Process timers
void updatetempo(struct _a7int *a7int)
{
unsigned count;
unsigned char *pstate=&a7int->pT[(2*sizeof(unsigned long)*a7int->nt)];
unsigned long *pt=(unsigned long *)a7int->pT;
static unsigned long lasttime;
unsigned long ellapsed;
if(a7int->pB[SYSTEM_BIT_FIRST_SCAN])
	{
	// First cycle: read current time
	lasttime=target_gettimeinms();
	for(count=0;count<a7int->nt;count++)
		{
		pt[1]=pt[0];
		}
	return;
	}
// Ellapsed time since last call
ellapsed=target_gettimeinms()-lasttime;
for(count=0;count<a7int->nt;count++)
	{
	unsigned char state;
	state=*pstate;
	state=((state&0xe0)<<1)|(state&0x1f);
	if(state&0x10)
		{ // Launched timer
		// Time ellapsed?
		if(pt[1]>0)
			{
			if(pt[1]>ellapsed) pt[1]-=ellapsed;
			else pt[1]=0;
			}
		if(pt[1]==0)
			{
			state|=0x20;
			}
		}
	else
		{ // Timer not launched : copy preset to counter
		pt[1]=pt[0];
		}
	*pstate=state;
	pstate++;
	pt+=2;
	}
lasttime+=ellapsed;
}

// Functions for AUTOMGEN actions
void equbool(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
setvar(a7int,type,num,state?1:0,pos);
}

void equbacc(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	a7int->ac16|=1<<type;
	}
else
	{
	a7int->ac16&=~(1<<type);
	}
}

void equbm(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	a7int->pM[num]|=1<<type;
	}
else
	{
	a7int->pM[num]&=~(1<<type);
	}
}

void neqbool(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
setvar(a7int,type,num,state?0:1,pos);
}

void neqbm(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
equbm(a7int,type,num,pos,state?0:1);
}

void neqbacc(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
equbacc(a7int,type,num,pos,state?0:1);
}

void setbool(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) setvar(a7int,type,num,1,pos);
}


void setbm(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	a7int->pM[num]|=1<<type;
	}
}

void setbacc(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	a7int->ac16|=1<<type;
	}
}

void resbacc(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	a7int->ac16&=~(1<<type);
	}
}

void resbool(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) setvar(a7int,type,num,0,pos);
}

void resbm(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	a7int->pM[num]&=~(1<<type);
	}
}


void invbool(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) setvar(a7int,type,num,2,pos);
}


void invbm(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	a7int->pM[num]^=1<<type;
	}
}

void invbacc(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	a7int->ac16^=1<<type;
	}
}

void setac16(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
a7int->ac16=-1;
}

void setac32(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
a7int->ac32=-1;
}

void resac16(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
a7int->ac16=0;
}

void invac16(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
a7int->ac16^=-1;
}


void resac32(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
a7int->ac32=0;
}

void invac32(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
a7int->ac32^=-1;
}

void incac32(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) a7int->ac32++;
}

void incac16(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) a7int->ac16++;
}


void inc(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) 
	{
	switch(type)
		{
		case 4 : a7int->pC[num]++; break;
		case 5 : a7int->pM[num]++; break;
		case 7 : a7int->pL[num]++; break;
		}
	}
}


void decac32(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) a7int->ac32--;
}

void decac16(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) a7int->ac16--;
}


void dec(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	switch(type)
		{
		case 4 : a7int->pC[num]--; break;
		case 5 : a7int->pM[num]--; break;
		case 7 : a7int->pL[num]--; break;
		}
	}
}

void jmp(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) 
	{
	a7int->movcode=((long)num)*4;
	}
}


void jsr(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	if(srstackpos==SRSTACKLEN)
		{
		#ifdef _SECURE
		a7int->pL[SYSTEM_WORD_ERROR_POSITION]=pos;
		a7int->pM[SYSTEM_WORD_ERROR_NUMBER]=AUTOMGEN_ERR_STACKOVERFLOW;
		a7int->pB[SYSTEM_BIT_INTERNAL_TABLE_OVERFLOW]=TRUEFORBOOL;
		a7int->pB[SYSTEM_BIT_EMERGENCY_STOP]=TRUEFORBOOL;
		target_fatal();
		#endif
		return;
		}
	srstack[srstackpos++]=a7int->curcode;
	a7int->movcode=((short)num)*4;
	}
}




void ldak16(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) a7int->ac16=(short)num;
}

void ldak32(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) a7int->ac32=(long)num;
}

void ldakf(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) memcpy(&a7int->acf,&num,4);
}


void adak16(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) a7int->ac16+=(short)num;
}

void adak32(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) a7int->ac32+=(long)num;
}

void adakf(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	float f;
	memcpy(&f,&num,4);
	a7int->acf+=f;
	}
}

void mlak16(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	unsigned long l;
	l=a7int->ac16*(short)num;
	a7int->ac16=(short)l;
	a7int->pM[0]=(short)(l>>16);
	}
}

void mlak32(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) a7int->ac32*=(long)num;
}

void mlakf(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	float f;
	memcpy(&f,&num,4);
	a7int->acf*=f;
	}
}


void dvak16(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) 
	{
	if(num) 
		{
		a7int->pM[0]=a7int->ac16%(short)num;
		a7int->ac16/=(short)num;
		}
	}
}

void dvak32(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	if(num) a7int->ac32/=(long)num;
	}
}

void dvakf(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	float f;
	memcpy(&f,&num,4);
	if(num)
		{
		a7int->acf/=f;
		}
	}
}

void sbak16(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) a7int->ac16-=(short)num;
}

void sbak32(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) a7int->ac32-=(long)num;
}

void sbakf(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	float f;
	memcpy(&f,&num,4);
	a7int->acf-=f;
	}
}

void cpak16(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	short save;
	save=a7int->ac16;
	sbak16(a7int,type,num,pos,state);
	a7int->sf=a7int->ac16<0;
	a7int->zf=a7int->ac16==0;
	a7int->ac16=save;
	}
}

void cpak32(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	long save;
	save=a7int->ac32;
	sbak32(a7int,type,num,pos,state);
	a7int->sf=a7int->ac32<0;
	a7int->zf=a7int->ac32==0;
	a7int->ac32=save;
	}
}

void cpakf(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	float save;
	save=a7int->acf;
	sbak16(a7int,type,num,pos,state);
	a7int->sf=a7int->acf<0;
	a7int->zf=a7int->acf==0;
	a7int->acf=save;
	}
}

void anak16(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) a7int->ac16&=num;
}

void tsak16(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	short save;
	save=a7int->ac16;
	anak16(a7int,type,num,pos,state);
	a7int->zf=a7int->ac16==0;
	a7int->ac16=save;
	}
}

void orak16(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) a7int->ac16|=num;
}

void xrak16(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) a7int->ac16^=num;
}

void anak32(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) a7int->ac32&=num;
}

void tsak32(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
long save;
save=a7int->ac16;
anak32(a7int,type,num,pos,state);
a7int->zf=a7int->ac32==0;
a7int->ac32=save;
}

void orak32(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) a7int->ac32|=num;
}

void xrak32(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) a7int->ac32^=(short)num;
}


void lda(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	switch(type)
		{
		case 3 : memcpy(&a7int->ac32,&a7int->pT[sizeof(unsigned long)+num*2*sizeof(unsigned long)],sizeof(unsigned long)); break;
		case 4 : a7int->ac16=a7int->pC[num]; break;
		case 5 : a7int->ac16=a7int->pM[num]; break;
		case 6 : a7int->acf=a7int->pF[num]; break;
		case 7 : a7int->ac32=a7int->pL[num]; break;
		}
	}
}



void ada(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) 
	{
	switch(type)
		{
		case 4 : a7int->ac16+=(short)a7int->pC[num]; break;
		case 5 : a7int->ac16+=(short)a7int->pM[num]; break;
		case 6 : a7int->acf+=a7int->pF[num]; break;
		case 7 : a7int->ac32+=(long)a7int->pL[num]; break;
		}
	}
}



void sba(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) 
	{
	switch(type)
		{
		case 4 : a7int->ac16-=(short)a7int->pC[num]; break;
		case 5 : a7int->ac16-=(short)a7int->pM[num]; break;
		case 6 : a7int->acf-=a7int->pF[num]; break;
		case 7 : a7int->ac32-=(long)a7int->pL[num]; break;
		}
	}
}


void mla(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) 
	{
	switch(type)
		{
		case 4 : 
			{
			long l;
			l=a7int->ac16*(short)a7int->pC[num];
			a7int->ac16=(short)l;
			a7int->pM[0]=(short)(l>>16);
			} break;
		case 5 : 
			{
			long l;
			l=a7int->ac16*(short)a7int->pM[num];
			a7int->ac16=(short)l;
			a7int->pM[0]=(short)(l>>16);
			} break;
		case 6 : a7int->acf*=a7int->pF[num]; break;
		case 7 : a7int->ac32*=(long)a7int->pL[num]; break;
		}
	}
}

void dva(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) 
	{
	switch(type)
		{
		case 4 : 
			{
			if(a7int->pC[num]) 
				{
				a7int->pM[0]=a7int->ac16%(short)a7int->pC[num];
				a7int->ac16/=(short)a7int->pC[num]; 
				}
			} break;
		case 5 : 
			{
			if(a7int->pM[num]) 
				{
				a7int->pM[0]=a7int->ac16%(short)a7int->pM[num];
				a7int->ac16/=(short)a7int->pM[num]; 
				}
			} break;
		case 6 : if(a7int->pF[num]!=0) a7int->acf/=a7int->pF[num]; break;
		case 7 : if(a7int->pL[num]) a7int->ac32/=(long)a7int->pL[num]; break;
		}
	}
}

void cpa(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) 
	{
	switch(type)
		{
		case 4 : 
			{
			short save;
			save=a7int->ac16;
			a7int->ac16-=(short)a7int->pC[num]; 
			a7int->sf=a7int->ac16<0;
			a7int->zf=a7int->ac16==0;
			a7int->ac16=save;
			} break;
		case 5 : 
			{
			short save;
			save=a7int->ac16;
			a7int->ac16-=(short)a7int->pM[num]; 
			a7int->sf=a7int->ac16<0;
			a7int->zf=a7int->ac16==0;
			a7int->ac16=save;
			} break;
		case 6 : 
			{
			float save;
			save=a7int->acf;
			a7int->acf-=a7int->pF[num]; 
			a7int->sf=a7int->acf<0;
			a7int->zf=a7int->acf==0;
			a7int->acf=save;
			} break;
		case 7 : 
			{
			long save;
			save=a7int->ac32;
			a7int->ac32-=(long)a7int->pL[num]; 
			a7int->sf=a7int->ac32<0;
			a7int->zf=a7int->ac32==0;
			a7int->ac32=save;
			} break;
		}
	}
}


void ana(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) 
	{
	switch(type)
		{
		case 4 : a7int->ac16&=a7int->pC[num]; break;
		case 5 : a7int->ac16&=a7int->pM[num]; break;
		case 7 : a7int->ac32&=a7int->pL[num]; break;
		}
	}
}

void tsa(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
}

void ora(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) 
	{
	switch(type)
		{
		case 4 : a7int->ac16|=a7int->pC[num]; break;
		case 5 : a7int->ac16|=a7int->pM[num]; break;
		case 7 : a7int->ac32|=a7int->pL[num]; break;
		}
	}
}
void xra(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	switch(type)
		{
		case 4 : a7int->ac16^=a7int->pC[num]; break;
		case 5 : a7int->ac16^=a7int->pM[num]; break;
		case 7 : a7int->ac32^=a7int->pL[num]; break;
		}
	}
}

void sta(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) 
	{
	switch(type)
		{
		case 3 : memcpy(&a7int->pT[num*2*sizeof(unsigned long)],&a7int->ac32,sizeof(unsigned long)); break;
		case 4 : a7int->pC[num]=a7int->ac16; break;
		case 5 : a7int->pM[num]=a7int->ac16; break;
		case 6 : a7int->pF[num]=a7int->acf; break;
		case 7 : a7int->pL[num]=a7int->ac32; break;
		}
	}
}

void rfc(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
setvar(a7int,type,num,a7int->cf?1:0,pos);
}

void rfz(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
setvar(a7int,type,num,a7int->zf?1:0,pos);
}

void rfs(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
setvar(a7int,type,num,a7int->sf?1:0,pos);
}

void rfo(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
setvar(a7int,type,num,a7int->of?1:0,pos);
}


void ret(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	if(srstackpos==0)
		{
		#ifdef _SECURE
		a7int->pL[SYSTEM_WORD_ERROR_POSITION]=pos;
		a7int->pM[SYSTEM_WORD_ERROR_NUMBER]=AUTOMGEN_ERR_STACKUNDERFLOW;
		a7int->pB[SYSTEM_BIT_INTERNAL_TABLE_OVERFLOW]=TRUEFORBOOL;
		a7int->pB[SYSTEM_BIT_EMERGENCY_STOP]=TRUEFORBOOL;
		target_fatal();
		#endif
		return;
		}
	a7int->gotocode=srstack[--srstackpos];
	lda(a7int,type,num,pos,1);
	}
}


void reta(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	if(srstackpos==0)
		{
		#ifdef _SECURE
		a7int->pL[SYSTEM_WORD_ERROR_POSITION]=pos;
		a7int->pM[SYSTEM_WORD_ERROR_NUMBER]=AUTOMGEN_ERR_STACKUNDERFLOW;
		a7int->pB[SYSTEM_BIT_INTERNAL_TABLE_OVERFLOW]=TRUEFORBOOL;
		a7int->pB[SYSTEM_BIT_EMERGENCY_STOP]=TRUEFORBOOL;
		target_fatal();
		#endif
		return;
		}
	a7int->gotocode=srstack[--srstackpos];
	}
}

void retk16(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	if(srstackpos==0)
		{
		#ifdef _SECURE
		a7int->pL[SYSTEM_WORD_ERROR_POSITION]=pos;
		a7int->pM[SYSTEM_WORD_ERROR_NUMBER]=AUTOMGEN_ERR_STACKUNDERFLOW;
		a7int->pB[SYSTEM_BIT_INTERNAL_TABLE_OVERFLOW]=TRUEFORBOOL;
		a7int->pB[SYSTEM_BIT_EMERGENCY_STOP]=TRUEFORBOOL;
		target_fatal();
		#endif
		return;
		}
	a7int->gotocode=srstack[--srstackpos];
	ldak16(a7int,type,num,pos,1);
	}
}

void retk32(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	if(srstackpos==0)
		{
		#ifdef _SECURE
		a7int->pL[SYSTEM_WORD_ERROR_POSITION]=pos;
		a7int->pM[SYSTEM_WORD_ERROR_NUMBER]=AUTOMGEN_ERR_STACKUNDERFLOW;
		a7int->pB[SYSTEM_BIT_INTERNAL_TABLE_OVERFLOW]=TRUEFORBOOL;
		a7int->pB[SYSTEM_BIT_EMERGENCY_STOP]=TRUEFORBOOL;
		target_fatal();
		#endif
		return;
		}
	a7int->gotocode=srstack[--srstackpos];
	ldak32(a7int,type,num,pos,1);
	}
}

void retkf(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	if(srstackpos==0)
		{
		#ifdef _SECURE
		a7int->pL[SYSTEM_WORD_ERROR_POSITION]=pos;
		a7int->pM[SYSTEM_WORD_ERROR_NUMBER]=AUTOMGEN_ERR_STACKUNDERFLOW;
		a7int->pB[SYSTEM_BIT_INTERNAL_TABLE_OVERFLOW]=TRUEFORBOOL;
		a7int->pB[SYSTEM_BIT_EMERGENCY_STOP]=TRUEFORBOOL;
		target_fatal();
		#endif
		return;
		}
	a7int->gotocode=srstack[--srstackpos];
	ldakf(a7int,type,num,pos,1);
	}
}

void rla16(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	a7int->ac16<<=num;
	}
}

void rra16(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	a7int->ac16>>=num;
	}
}


void rla32(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	a7int->ac32<<=num;
	}
}

void rra32(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	a7int->ac32>>=num;
	}
}


void atb(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	unsigned count;
	for(count=0;count<16;count++)
		{
		setvar(a7int,type,num,a7int->ac16&(1<<count)?1:0,pos);
		num++;
		}
	}
}


void bta(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	unsigned count;
	a7int->ac16=0;
	for(count=0;count<16;count++)
		{
		switch(type)
			{
			case 0 : if(a7int->pI[num]&0x20) a7int->ac16|=1<<count; break;
			case 1 : if(a7int->pO[num]&0x20) a7int->ac16|=1<<count; break;
			case 2 : if(a7int->pB[num]&0x20) a7int->ac16|=1<<count; break;
			case 3 : if(a7int->pT[num]&0x20) a7int->ac16|=1<<count; break;
			}
		num++;
		}
	}
}


void sqr(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	a7int->acf=(float)sqrt(a7int->acf);
	}
}

void nor(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
}

void abs_(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	a7int->acf=(float)fabs(a7int->acf);
	}
}

void fti(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	a7int->ac16=(short)a7int->acf;
	}
}

void itf(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	a7int->acf=(float)a7int->ac16;
	}
}


void itl(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	a7int->ac32=(long)a7int->ac16;
	}
}
void lti(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	a7int->ac16=(short)a7int->ac32;
	}
}


void sin_(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	a7int->acf=(float)sin(a7int->acf);
	}
}


void cos_(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	a7int->acf=(float)cos(a7int->acf);
	}
}

void tan_(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	a7int->acf=(float)tan(a7int->acf);
	}
}

void asin_(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	a7int->acf=(float)asin(a7int->acf);
	}
}

void acos_(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	a7int->acf=(float)acos(a7int->acf);
	}
}

void atan_(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
	a7int->acf=(float)atan(a7int->acf);
	}
}

void aou(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
   if(type==5)
   	{
		target_aou(a7int,a7int->pM[num],0);
      }
	}
}

void aouk16(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) target_aou(a7int,num,0);
}

void aouk32(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) target_aou(a7int,num,1);
}

void ain(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state)
	{
   if(type==5)
   	{
		target_ain(a7int,a7int->pM[num],0);
      }
	}
}

void aink16(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) target_ain(a7int,num,0);
}

void aink32(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) target_ain(a7int,num,1);
}

void funk16(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) target_fun(a7int,num);
}

void funk32(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
if(state) target_fun(a7int,num);
}

void badadr(struct _a7int *a7int, unsigned char type,unsigned long num,unsigned pos,int state)
{
#ifdef _SECURE
a7int->pL[SYSTEM_WORD_ERROR_POSITION]=pos;
a7int->pM[SYSTEM_WORD_ERROR_NUMBER]=AUTOMGEN_ERR_ILLEGALACTIONADRCODE;
a7int->pB[SYSTEM_BIT_INTERNAL_TABLE_OVERFLOW]=TRUEFORBOOL;
a7int->pB[SYSTEM_BIT_EMERGENCY_STOP]=TRUEFORBOOL;
target_fatal();
#endif
}


typedef struct
	{
	void (*proc)(struct _a7int *a7int,unsigned char type,unsigned long num,unsigned pos,int state);
	} actionprocitem;


// Function matrix OPCODE / ADRESS MODE
actionprocitem actionproc[MAXACTIONOPCODE][MAXADR]=
{
// ABS		IND			IMM16		LAB			ACC16		IMM32L		IMM32F		ACC32		ACCF		BACC		BM
{equbool,	equbool,	badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		equbacc,	equbm},
{neqbool,	neqbool,	badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		neqbacc,	neqbm},
{setbool,	setbool,	badadr,		badadr,		setac16,	badadr,		badadr,		setac32,	badadr,		setbacc,	setbm},
{resbool,	resbool,	badadr,		badadr,		resac16,	badadr, 	badadr,		resac32,	badadr,		resbacc,	resbm},
{invbool,	invbool,	badadr,		badadr,		invac16,	badadr, 	badadr,		invac32,	badadr,		invbacc,	invbm},
{inc,		inc,		badadr,		badadr,		incac16,	badadr,		badadr,		incac32,	badadr,		badadr,		badadr},
{dec,		dec,		badadr,		badadr,		decac16,	badadr,		badadr,		decac32,	badadr,		badadr,		badadr},
{badadr,		badadr,		badadr,		jmp,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr},
{lda,		lda,		ldak16,		badadr,		badadr,		ldak32,		ldakf,		badadr,		badadr,		badadr,		badadr},
{sta,		sta,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr},
{rfc,		rfc,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr},
{rfz,		rfz,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr},
{rfs,		rfs,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr},
{rfo,		rfo,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr},
{ada,		ada,		adak16,		badadr,		badadr,		adak32,		adakf,		badadr,		badadr,		badadr,		badadr},
{sba,		sba,		sbak16,		badadr,		badadr,		sbak32,		sbakf,		badadr,		badadr,		badadr,		badadr},
{cpa,		cpa,		cpak16,		badadr,		badadr,		cpak32,		cpakf,		badadr,		badadr,		badadr,		badadr},
{mla,		mla,		mlak16,		badadr,		badadr,		mlak32,		mlakf,		badadr,		badadr,		badadr,		badadr},
{dva,		dva,		dvak16,		badadr,		badadr,		dvak32,		dvakf,		badadr,		badadr,		badadr,		badadr},
{ana,		ana,		anak16,		badadr,		badadr,		anak32,		badadr,		badadr,		badadr,		badadr,		badadr},
{ora,		ora,		orak16,		badadr,		badadr,		orak32,		badadr,		badadr,		badadr,		badadr,		badadr},
{xra,		xra,		xrak16,		badadr,		badadr,		xrak32,		badadr,		badadr,		badadr,		badadr,		badadr},
{badadr,		badadr,		badadr,		jsr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr},
{ret,		ret,		retk16,		badadr,		reta,		retk32,		retkf,		reta,		reta,		badadr,		badadr},
{badadr,		badadr,		rla16,		badadr,		badadr,		rla32,		badadr,		badadr,		badadr,		badadr,		badadr},
{badadr,		badadr,		rra16,		badadr,		badadr,		rra32,		badadr,		badadr,		badadr,		badadr,		badadr},
{tsa,		tsa,		tsak16,		badadr,		badadr,		tsak32,		badadr,		badadr,		badadr,		badadr,		badadr},
{atb,		atb,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr},
{bta,		bta,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr},
{ain,		badadr,		aouk16,		badadr,		badadr,		aouk32,		badadr,		badadr,		badadr,		badadr,		badadr},
{aou,		badadr,		aink16,		badadr,		badadr,		aink32,		badadr,		badadr,		badadr,		badadr,		badadr},
{badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr},
{badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr},
{badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr},
{badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr},
{badadr,		badadr,		badadr,		badadr,		sqr,		badadr,		badadr,		sqr,		sqr,		badadr,		badadr},
{badadr,		badadr,		badadr,		badadr,		nor,		badadr,		badadr,		nor,		nor,		badadr,		badadr},
{badadr,		badadr,		badadr,		badadr,		abs_,		badadr,		badadr,		abs_,		abs_,		badadr,		badadr},
{badadr,		badadr,		badadr,		badadr,		fti,		badadr,		badadr,		fti,		fti,		badadr,		badadr},
{badadr,		badadr,		badadr,		badadr,		itf,		badadr,		badadr,		itf,		itf,		badadr,		badadr},
{badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr},
{badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr},
{badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr},
{badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr},
{badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr},
{badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr},
{badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr,		badadr},
{badadr,		badadr,		badadr,		badadr,		itl,		badadr,		badadr,		itl,		itl,		badadr,		badadr},
{badadr,		badadr,		badadr,		badadr,		lti,		badadr,		badadr,		lti,		lti,		badadr,		badadr},
{badadr,		badadr,		badadr,		badadr,		sin_,		badadr,		badadr,		sin_,		sin_,		badadr,		badadr},
{badadr,		badadr,		badadr,		badadr,		cos_,		badadr,		badadr,		cos_,		cos_,		badadr,		badadr},
{badadr,		badadr,		badadr,		badadr,		tan_,		badadr,		badadr,		tan_,		tan_,		badadr,		badadr},
{badadr,		badadr,		badadr,		badadr,		asin_,		badadr,		badadr,		asin_,		asin_,		badadr,		badadr},
{badadr,		badadr,		badadr,		badadr,		acos_,		badadr,		badadr,		acos_,		acos_,		badadr,		badadr},
{badadr,		badadr,		badadr,		badadr,		atan_,		badadr,		badadr,		atan_,		atan_,		badadr,		badadr},
{badadr,		badadr,		funk16,		badadr,		badadr,		funk32,		badadr,		badadr,		badadr,		badadr,		badadr},

};


// Execute the program one time
void automgenintrun(struct _a7int *a7int)
{
BYTE *oricode;
BYTE opcode;
BYTE *paction=NULL,*ptest=NULL;
BYTE *code;
int ltest=0;
code=a7int->progmem;
if(!code)
	{
	a7int->pM[SYSTEM_WORD_ERROR_NUMBER]=AUTOMGEN_ERR_NOPROG;
	a7int->pB[SYSTEM_BIT_FAULT]=TRUEFORBOOL;
	a7int->pB[SYSTEM_BIT_EMERGENCY_STOP]=TRUEFORBOOL;
	target_fatal();
	return;
	}
oricode=code;
do
	{
	opcode=*code;
   //printf("%2.2X\r\n",opcode);
	if(opcode>=128)
		{ // Action
		// Process the previous action
		if(paction)
			{
			int postest=0,testresult=1,testresultpush,lasttest=-1,extrapostest=0;
			if(ltest>0) // A test ?
				{
				int curresult;
				// Evaluate the test
				while(postest<ltest)
					{
					// Evaluate the item
					unsigned result,num32;
					float numf;
					unsigned short num16;
					unsigned adr;
					adr=(ptest[postest]&0xc)>>2;
					switch(adr)
						{
						case 0 : // Absolute
						case 1 : // Indirect
							{
							unsigned num;
							num=ptest[postest+2]+(ptest[postest+3]<<8);
							if(adr==1)
								{ // Indirect
								num=a7int->pM[num];
								}
							switch(ptest[postest+1]&0xf) // Variable type
								{
								case 0 : // I
									result=a7int->pI[num];
									break;
								case 1 : // O
									result=a7int->pO[num];
									break;
								case 2 : // B
									result=a7int->pB[num];
									break;
								case 3 : // T
									result=a7int->pT[(2*sizeof(unsigned long)*a7int->nt)+num];
									break;
								case 4 : // C
								case 5 : // M
								case 6 : // F
								case 7 : // L
									{
									unsigned var,typtest,vartest,adrtest,signtest;
									var=ptest[postest+1]&0xf;
									typtest=ptest[postest+5]&3;
									vartest=(ptest[postest+5]>>2)&3;
									adrtest=(ptest[postest+5]>>4)&1;
									signtest=(ptest[postest+5]>>5)&1;
									num16=ptest[postest+6]+(ptest[postest+7]<<8);
									if((var==6||var==7)&&vartest==0)
										{ // get a 32 bits constant
										if(var==7)
											{
											memcpy(&num32,&ptest[postest+8],4);
											}
										else
											{
											memcpy(&numf,&ptest[postest+8],4);
											}
										extrapostest+=4;
										}
									#ifdef _SECURE
									if(
									((var==4||var==5)&&(vartest==3))
									||
									((var==6||var==7)&&(vartest==1||vartest==2))
									)
										{
										a7int->pL[SYSTEM_WORD_ERROR_POSITION]=paction-oricode;
										a7int->pM[SYSTEM_WORD_ERROR_NUMBER]=AUTOMGEN_ERR_ILLEGALNUMTEST;
										a7int->pB[SYSTEM_BIT_FAULT]=TRUEFORBOOL;
										a7int->pB[SYSTEM_BIT_EMERGENCY_STOP]=TRUEFORBOOL;
										target_fatal();
										return;
										}
									#endif
									switch(vartest)
										{
										case 0 : break; // constant
										case 1 : // count
											{
											if(adrtest) num16=a7int->pM[num16];
											num16=a7int->pC[num16];
											} break;
										case 2 : // word
											{
											if(adrtest) num16=a7int->pM[num16];
											num16=a7int->pM[num16];
											} break;
										case 3 : // dword or float
											{
											if(adrtest) num16=a7int->pM[num16];
											if(var==7) num32=a7int->pL[num16];
											else memcpy(&numf,&a7int->pF[num16],4);
											} break;
										}
									switch(var)
										{
										case 4 :
											{
											switch(typtest+(signtest<<2))
												{
												case 4 :
												case 0 : result=a7int->pC[num]==num16?0xf0:0; break;
												case 5 :
												case 1 : result=a7int->pC[num]!=num16?0xf0:0; break;
												case 2 : result=a7int->pC[num]<num16?0xf0:0; break;
												case 3 : result=a7int->pC[num]>num16?0xf0:0; break;
												case 6 : result=(short)a7int->pC[num]<(short)num16?0xf0:0; break;
												case 7 : result=(short)a7int->pC[num]>(short)num16?0xf0:0; break;
												}
											} break;
										case 5 :
											{
											switch(typtest+(signtest<<2))
												{
												case 4 :
												case 0 : result=a7int->pM[num]==num16?0xf0:0; break;
												case 5 :
												case 1 : result=a7int->pM[num]!=num16?0xf0:0; break;
												case 2 : result=a7int->pM[num]<num16?0xf0:0; break;
												case 3 : result=a7int->pM[num]>num16?0xf0:0; break;
												case 6 : result=(short)a7int->pM[num]<(short)num16?0xf0:0; break;
												case 7 : result=(short)a7int->pM[num]>(short)num16?0xf0:0; break;
												}
											} break;
										case 6 :
											{
											switch(typtest)
												{
												case 0 : result=a7int->pF[num]==numf?0xf0:0; break;
												case 1 : result=a7int->pF[num]!=numf?0xf0:0; break;
												case 2 : result=a7int->pF[num]<numf?0xf0:0; break;
												case 3 : result=a7int->pF[num]>numf?0xf0:0; break;
												}
											} break;
										case 7 :
											{
											switch(typtest+(signtest<<2))
												{
												case 4 :
												case 0 : result=a7int->pL[num]==num32?0xf0:0; break;
												case 5 :
												case 1 : result=a7int->pL[num]!=num32?0xf0:0; break;
												case 2 : result=a7int->pL[num]<num32?0xf0:0; break;
												case 3 : result=a7int->pL[num]>num32?0xf0:0; break;
												case 6 : result=(short)a7int->pL[num]<(short)num32?0xf0:0; break;
												case 7 : result=(short)a7int->pL[num]>(short)num32?0xf0:0; break;
												}
											} break;
										}
									extrapostest+=4;
									} break;
								#ifdef _SECURE
								default :
									{
									a7int->pL[SYSTEM_WORD_ERROR_POSITION]=paction-oricode;
									a7int->pM[SYSTEM_WORD_ERROR_NUMBER]=AUTOMGEN_ERR_ILLEGALTESTVAR;
									a7int->pB[SYSTEM_BIT_FAULT]=TRUEFORBOOL;
									a7int->pB[SYSTEM_BIT_EMERGENCY_STOP]=TRUEFORBOOL;
									target_fatal();
									}
								#endif
								}
							} break;
						case 2 : // Bit of the 16 bits accumulator
							{
							result=(a7int->ac16&(1<<ptest[postest+1]&0xf))?0xf0:0;
							} break;
						case 3 : // Bit of a word
							{
							result=(a7int->pM[ptest[postest+2]+(ptest[postest+3]<<8)]&(1<<(ptest[postest+1]&0xf)))?0xf0:0;
							} break;
						#ifdef _SECURE
						default :
							{
							a7int->pL[SYSTEM_WORD_ERROR_POSITION]=paction-oricode;
							a7int->pM[SYSTEM_WORD_ERROR_NUMBER]=AUTOMGEN_ERR_ILLEGALTESTADR;
							a7int->pB[SYSTEM_BIT_FAULT]=TRUEFORBOOL;
							a7int->pB[SYSTEM_BIT_EMERGENCY_STOP]=TRUEFORBOOL;
							target_fatal();
							}
						#endif
						}
					switch(ptest[postest+1]>>4) // Test type
						{
						case 0 : // =1
							curresult=(result&0x20)?1:0;
							break;
						case 1 : // =0
							curresult=(result&0x20)?0:1;
							break;
						case 2 : // raising edge
							curresult=((result&0x60)==0x20)?1:0;
							break;
						case 3 : // folling edge
							curresult=((result&0x60)==0x40)?1:0;
							break;
						case 4 : // =1 immediat
							curresult=(result&0x10)?1:0;
							break;
						case 5 : // =0 immediat
							curresult=(result&0x10)?0:1;
							break;
						#ifdef _SECURE
						default :
							{
							a7int->pL[SYSTEM_WORD_ERROR_POSITION]=paction-oricode;
							a7int->pM[SYSTEM_WORD_ERROR_NUMBER]=AUTOMGEN_ERR_ILLEGALTESTTYPE;
							a7int->pB[SYSTEM_BIT_FAULT]=TRUEFORBOOL;
							a7int->pB[SYSTEM_BIT_EMERGENCY_STOP]=TRUEFORBOOL;
							target_fatal();
							}
						#endif
						}
					switch(ptest[postest]&3) // Test opcodes
						{
						case 0 : testresult&=curresult; break;	// AND
						case 1 :
							{
							if(lasttest!=1)
								{
								testresultpush=testresult;
								testresult=0;
								}
							testresult|=curresult;		// ORR
							} break;
						case 2 :
							{
							testresult|=curresult;			// EOR
							testresult&=testresultpush;
							} break;
						#ifdef _SECURE
						default :
							{
							a7int->pL[SYSTEM_WORD_ERROR_POSITION]=paction-oricode;
							a7int->pM[SYSTEM_WORD_ERROR_NUMBER]=AUTOMGEN_ERR_ILLEGALTESTOPCODE;
							a7int->pB[SYSTEM_BIT_FAULT]=TRUEFORBOOL;
							a7int->pB[SYSTEM_BIT_EMERGENCY_STOP]=TRUEFORBOOL;
							target_fatal();
							}
						#endif
						}
					lasttest=ptest[postest]&3;
					postest+=4+extrapostest;
					extrapostest=0;
					}
				}
			if(paction[0]==0xfe) break;
			#ifdef _SECURE
			if(paction[0]>MAXACTIONOPCODE)
				{
				a7int->pL[SYSTEM_WORD_ERROR_POSITION]=paction-oricode;
				a7int->pM[SYSTEM_WORD_ERROR_NUMBER]=AUTOMGEN_ERR_ILLEGALACTIONOPCODE;
				a7int->pB[SYSTEM_BIT_FAULT]=TRUEFORBOOL;
				a7int->pB[SYSTEM_BIT_EMERGENCY_STOP]=TRUEFORBOOL;
				target_fatal();
				}
			else
			#endif
				{
				unsigned char type;
				unsigned long num;
				switch(paction[1]>>4) // Adress mode
					{
					case 0x00 :  // Absolute
						{
						type=paction[1]&0xf;
						num=*((unsigned short *)(&paction[2]));
						} break;
					case 0x01 : // Indirect
						{
						type=paction[1]&0xf;
						num=a7int->pM[*((unsigned short *)(&paction[2]))];
						} break;
					case 0x02 : // Immediat 16 bits
						{
						num=*((unsigned short *)(&paction[2]));
						} break;
					case 0x03 : // Label
						{
						num=*((unsigned short *)(&paction[2]));
						} break;
					case 0x04 : break; // 16 bits accumulator
					case 0x05 : // 32 bits immediat
						{
						num=*((unsigned long *)(&paction[4]));
						} break;
					case 0x06 : // 32 bits immediat float point
						{
						num=*((unsigned long *)(&paction[4]));
						} break;
					case 0x07 : break; // 32 bits accumulator
					case 0x08 : break; // Floating point accumulator
					case 0x09 : // Bit of the 16 bits accumulator
						{
						type=paction[1]&0xf;
						} break;
					case 0x0a : // Bit of a word
						{
						type=paction[1]&0xf;
						num=*((unsigned short *)(&paction[2]));
						} break;
					default :
						{
						a7int->pL[SYSTEM_WORD_ERROR_POSITION]=paction-oricode;
						a7int->pM[SYSTEM_WORD_ERROR_NUMBER]=AUTOMGEN_ERR_ILLEGALACTIONADRCODE;
						a7int->pB[SYSTEM_BIT_INTERNAL_TABLE_OVERFLOW]=TRUEFORBOOL;
						a7int->pB[SYSTEM_BIT_EMERGENCY_STOP]=TRUEFORBOOL;
						target_fatal();
						} break;
					}
				a7int->movcode=(DWORD)-1;
				a7int->curcode=code;
				(actionproc[paction[0]-0x80][paction[1]>>4].proc)(a7int,type,num,paction-oricode,testresult);
				if(a7int->gotocode)
					{
					code=a7int->gotocode;
					opcode=*code;
					a7int->gotocode=NULL;
					}
				if(a7int->movcode!=(DWORD)-1)
					{
					code=paction+a7int->movcode;
					a7int->movcode=(DWORD)-1;
					opcode=*code;
					}
				}
			if(opcode==0xfe)
				{
				break; // End of program
				}
			}
		paction=code;
		ptest=NULL;
		ltest=0;
		code+=4;
		// Opcode with more than 4 bytes per instruction ?
		switch(paction[1]>>4)
			{
			case 5 :
			case 6 :
				{
				code+=4;
				} break;
			}
		}
	else
		{ // Test
		int extratestlen=0;
		unsigned var;
		if(ptest==NULL) ptest=code;
		var=(ptest[1]&0xf);
		switch(var)
			{
			case 4 :
			case 5 :
				{
				extratestlen+=4;
				} break;
			case 6 :
			case 7 :
				{
				extratestlen+=4;
				if(((ptest[5]>>2)&3)==0)
					{
					extratestlen+=4;
					}
				} break;
			}

		ltest+=4+extratestlen;
		code+=4+extratestlen;
		}
	}	
while(1);
#ifndef NOFORCE
processforce(a7int); // Process forcings
#endif
updatebool(a7int); // Process boolean variable states 
updatetempo(a7int); // Process timers
a7int->pB[SYSTEM_BIT_FIRST_SCAN]=0; // Reset first scan bit
}


// Program initialization
void automgenintinit(struct _a7int *a7int)
{
unsigned count,len;
unsigned long *pt;
srstackpos=0;
// Reset boolean variables and timers
if(a7int->ni) memset(a7int->pI,0,a7int->ni);
if(a7int->no) memset(a7int->pO,0,a7int->no);
if(a7int->nb) memset(a7int->pB,0,a7int->nb);
if(a7int->nt) memset(&a7int->pT[2*sizeof(unsigned long)*a7int->nt],0,a7int->nt);
// Numerical variables are not reseted by default
//if(a7int->nc) memset(a7int->pC,0,a7int->nc*sizeof(unsigned short));
//if(a7int->nm) memset(a7int->pM,0,a7int->nm*sizeof(unsigned short));
//if(a7int->nf) memset(a7int->pL,0,a7int->nf*sizeof(float));
//if(a7int->nl) memset(a7int->pF,0,a7int->nl*sizeof(unsigned long));
// Copy timers preset into timers counter
pt=(unsigned long *)a7int->pT;
len=a7int->nt;
for(count=0;count<len;count++)
	{
	pt[1]=pt[0];
	pt+=2;
	}
a7int->pB[SYSTEM_BIT_FIRST_SCAN]=TRUEFORBOOL; 
// Timer words
a7int->pM[30]=0;
a7int->pM[31]=0;
a7int->pM[32]=0;
a7int->pM[33]=0;
a7int->pM[34]=0;
a7int->pM[35]=1;
a7int->pM[36]=5;
a7int->pM[37]=10;
a7int->pM[38]=20;
a7int->pM[39]=50;
}


// Process system variables
void automgenintprocesssysvar(struct _a7int *a7int)
{
static DWORD lasttick;
WORD ms,sec,min,hour,day,month,year;

a7int->pB[SYSTEM_BIT_RUN]=a7int->run?0xff:0;

if(a7int->pB[36])
	{
	target_readrtc(&ms,&sec,&min,&hour,&day,&month,&year);
	a7int->pM[1]=ms;
	a7int->pM[4]=ms/100;
	a7int->pM[5]=sec;
	a7int->pM[6]=min;
	a7int->pM[7]=hour;
	a7int->pM[8]=day;
	a7int->pM[51]=month;
	a7int->pM[52]=year;
   }
if(a7int->pB[37])
	{
	ms=a7int->pM[1];
	sec=a7int->pM[5];
  	min=a7int->pM[6];
	hour=a7int->pM[7];
	day=a7int->pM[8];
	month=a7int->pM[51];
	year=a7int->pM[52];
	target_writertc(ms,sec,min,hour,day,month,year);
   }


// Timer bits
if(a7int->pB[SYSTEM_BIT_FIRST_SCAN]&0x40) 
	lasttick=target_gettimeinms();
else						  
	{
	DWORD ncent;
	DWORD curtick=target_gettimeinms(),ellapsed;
	unsigned count;
	ellapsed=curtick-lasttick;
	ncent=ellapsed/100;
	lasttick+=ncent*100;
	for(count=0;count<5;count++)
		{
		WORD w;
		w=a7int->pM[30+count];
		w+=(unsigned short)ncent;
		if(w>=a7int->pM[35+count]) 
			{
			a7int->pM[30+count]=0;
			a7int->pB[30+count]=(a7int->pB[30+count]&0x40)?0:TRUEFORBOOL;
			}
		else
			{
			a7int->pM[30+count]=w;
			}
		}
	}
}





