// AUTOMGEN interpretor runtime	 - target
// Target specific file : LINUX
// (C) 2010 IRAI

#include "stdlib.h"
#include "stdio.h"
#include "memory.h"
#include "netdb.h"
#include "arpa/inet.h"
#include "netinet/in.h"
#include "core.h"
#include "sys/times.h"
#include "sys/ioctl.h"
#include "linux/sockios.h"
//#include "sys/io.h"
#include "unistd.h"
#include "ctype.h"
#include <ctime>
#include "com.h"
#include "_io.h"
#include "fcntl.h"
#include "sys/time.h"
#include "errno.h"
#define VERSION 1
#define RELEASE 0

//
// General functions
//
#define BYTE unsigned char
#define WORD unsigned short
#define DWORD unsigned long

// Must return current time in ms in a DWORD, no matter the starting value
DWORD target_gettimeinms(void)
{
/*  
struct tms tm;
return times(&tm)*10; 
*/
 struct timeval tv;
 
 gettimeofday(&tv, NULL);
 
 uint64_t ret = tv.tv_usec;
 /* Convert from micro seconds (10^-6) to milliseconds (10^-3) */
 ret /= 1000;
 
 /* Adds the seconds (10^0) after converting them to milliseconds (10^-3) */
 ret += (tv.tv_sec * 1000);
 
 return ret;

}

// Return RTC time
void target_readrtc(unsigned short *ms,unsigned short *sec,unsigned short *min,unsigned short *hour,unsigned short *day,unsigned short *month,unsigned short *year)
{
}

// Write RTC time
void target_writertc(unsigned short ms,unsigned short sec,unsigned short min,unsigned short hour,unsigned short day,unsigned short month,unsigned short year)
{
}

// Called when a fatal error occurs
void target_fatal(void)
{
}

// Return a 16 chars string target identifier
char *target_id(void)
{
static char id[17]="AGN LINUX RT V10";
return id;
}

// Return a byte with bits as follow :
// b0= 0: time base 1ms (alsways 0, for 1 is for backward compatibility)
// b1= 0: integers are coded with LSB first, 1: integers are coded with MSB first
// b2= 0: no tiny web server, 1: tiny web server
unsigned char target_confbyte(void)
{
return 4;
}

//
// Serial communication functions
//

int beck_serialport=-1;

// Open a serial port
int target_com_open(unsigned port,unsigned long speed,unsigned parity,unsigned databit,unsigned stopbit)
{
return -1;
}


// Send a buffer to serial port
void target_com_send(unsigned char *buff,unsigned len)
{
}


// Is there one or more chars in RX buffer?
int target_com_ischarin(void)
{
return 0;
}

// Get one char
int target_com_getchar(void)
{
return 0;
}

// Close serial com port
void target_com_close(void)
{
}

//
// TCP-IP functions
//



#define MAXCLIENTSOCK 5			// Max client connections
#define MAX_PENDING_CONNECTS  5     // Maximum length of the queue of pending connections
//#define MAXDATAINLEN 0x100

#pragma pack(1)

#define INVALID_SOCKET -1

int Socket=INVALID_SOCKET;
int ClientSock[MAXCLIENTSOCK];
DWORD ClientID[MAXCLIENTSOCK];
struct sockaddr_in local_sin,accept_sin;
int accept_sin_len;
//unsigned maxtramelen;

// TCP-IP initialization
int target_netcom_start(void)
{
unsigned count;
for(count=0;count<MAXCLIENTSOCK;count++)
	{
	ClientSock[count]=INVALID_SOCKET;
	}
//maxtramelen=0x1000;
return 0;    
}

// TCP-IP close
int target_netcom_close(void)
{
return 0;
}


//#define MAXRECEIVELEN 0x1000

unsigned char cliconnected[MAXCLIENTSOCK];
unsigned char cchar[MAXCLIENTSOCK];
unsigned char ccharexist[MAXCLIENTSOCK]; 

// How many bytes in RX buffer?
int target_netcom_srvgetlenin(unsigned client)
{
int err,result=0;
if(!cliconnected[client]) return -1;
err=ioctl(ClientSock[client],SIOCINQ,&result);
if(err!=0) return -1;
if(result==0)
   {
   int result,err;
   unsigned char data;
   // V�rifier que le socket est toujours valide
   if((result=recv(ClientSock[client],&data,1,MSG_DONTWAIT))<0)
   	{
      if(result<0)  // Client d�connect�
      	{
	  if(errno!=11)
	    {
	  close(ClientSock[client]);
	  return -1;
	    }
	    }
      }
   else
   	{
      // Replacer le caract�re lu dans la file
      ccharexist[client]=1;
      cchar[client]=data;
      }
   }

return result;
}


// Read datas from a client
int target_netcom_srvread(unsigned client,unsigned char *data,unsigned maxdata)
{
int len;
if(!cliconnected[client]) return -1;
int err,result=0;
err=ioctl(ClientSock[client],SIOCINQ,&result);
if(err!=0) return -1;
len=result+ccharexist[client];
if(len>maxdata) len=maxdata;
if(ccharexist[client])
    {
   ccharexist[client]=0;
   data[0]=cchar[client];
   if(len==1)
      {
      return 1;
      }
  return recv(ClientSock[client],&data[1],len-1,MSG_DONTWAIT)+1;
   }

return recv(ClientSock[client],data,len,MSG_DONTWAIT);
}


// Get first connected client number : return -1 if none
int target_netcom_srvgetfirstclient(void)
{
unsigned count;
// Test new client connection
unsigned pos;
int clisocket;
int err;
socklen_t sl;
accept_sin_len = sizeof (accept_sin);
sl=sizeof(struct sockaddr_in);
clisocket=accept(Socket,(sockaddr *)&accept_sin,&sl);
if(clisocket!=-1)
	{
   // Search a free space for this connection
	pos=0;
	while(pos<MAXCLIENTSOCK)
		{
		if(ClientSock[pos]==INVALID_SOCKET) break;
		pos++;
		}
	if(pos!=MAXCLIENTSOCK) // Found!
		{
      ClientSock[pos]=clisocket;
      cliconnected[pos]=1;
		}
	}
for(count=0;count<MAXCLIENTSOCK;count++)
	{
   if(ClientSock[count]!=INVALID_SOCKET&&target_netcom_srvgetlenin(count)<0)
   	{
      cliconnected[count]=0;
      ClientSock[count]=INVALID_SOCKET;
      }
	if(cliconnected[count]) return count;
	}
return -1;
}

// Get next connected client : return -1 if none
int target_netcom_srvgetnextclient(unsigned cli)
{
unsigned count;
for(count=cli+1;count<MAXCLIENTSOCK;count++)
	{
	if(cliconnected[count]) return count;
	}
return -1;
}




// Oopen a TCP-IP server
int target_netcom_srvopen(int (*netevent)(struct _NE *pne),WORD port)
{
int err;
if((Socket=socket(PF_INET,SOCK_STREAM,IPPROTO_TCP))==-1)
  {
  return -1;
  }
fcntl(Socket,F_SETFL,O_NONBLOCK);
// Fill out the local socket's address information.
memset(&local_sin,0,sizeof(local_sin));
local_sin.sin_family = AF_INET;
local_sin.sin_port = htons(port);
local_sin.sin_addr.s_addr =INADDR_ANY;
// Associate the local address with WinSocket.
if (bind(Socket,(struct sockaddr *) &local_sin,sizeof(struct sockaddr)) !=0)
  {
  close(Socket);
  return -2;
  }

// Establish a socket to listen for incoming connections.
if(listen(Socket,5)!=0)
  {
  close(Socket);
  return -3;
  }
/*
if(Set_Blocking_Mode(Socket,0,&err)!=0)
	{
  close(Socket);
   return -4;
   }
*/
return 0;
}

int target_netcom_srvclose(void)
{
unsigned count;
int err;
close(Socket);
for(count=0;count<MAXCLIENTSOCK;count++)
	{
	if(ClientSock[count]!=INVALID_SOCKET)
		{
      int err;
		// Disable both sending and receiving on ClientSock.
		shutdown(ClientSock[count],0x02);
		close(ClientSock[count]);
		ClientSock[count]=INVALID_SOCKET;
		}
	}
return 0;
}



int target_netcom_srvsenddata(int pos,BYTE *data,int len)
{
int err;
if(send(ClientSock[pos],(char *)data,len,0)==-1)
	{
	return -1;
	}
return 0;
}

#define PROGFILENAME "automgen_prog.bin"
#define PRDFILENAME "automgen_prd.bin"


int target_prog_exist(void)
{
if(access(PROGFILENAME,0)==0) return 1;
return 0;
}

int target_prd_exist(void)
{
if(access(PRDFILENAME,0)==0) return 1;
return 0;
}

int target_prog_delete(void)
{
unlink(PROGFILENAME);
unlink(PRDFILENAME);
return 0;
}

int target_prd_save(unsigned char type,unsigned short num,unsigned long value)
{
FILE *f;
f=fopen(PRDFILENAME,"ab");
if(!f) return -1;
if(fwrite(&type,1,1,f)!=1||fwrite(&num,2,1,f)!=1||fwrite(&value,4,1,f)!=1)
	{
   fclose(f);
   return -2;
   }
fclose(f);
return 0;
}


unsigned long filel(FILE *file)
{
unsigned long curpos,pos;
curpos=ftell(file);
fseek(file,0,SEEK_END);
pos=ftell(file);
fseek(file,curpos,SEEK_SET);
return pos;
}


int target_prd_load(struct _a7int *a7int)
{
unsigned len,count;
unsigned char type;
unsigned short num;
unsigned long val;
FILE *f;
f=fopen(PRDFILENAME,"rb");
if(f==NULL)
	{
   return -1;
   }
len=filel(f);
for(count=0;count<len;count+=7)
	{
   if(fread(&type,1,1,f)!=1||fread(&num,2,1,f)!=1||fread(&val,4,1,f)!=1)
   	{
      fclose(f);
      return -2;
      }
   switch(type)
   	{
      case 3 : if(num<a7int->nt) *((DWORD *)&a7int->pT[num*sizeof(unsigned long)*2])=val; break;
      case 4 : if(num<a7int->nc) a7int->pC[num]=(unsigned short)val; break;
      case 5 : if(num<a7int->nm) a7int->pM[num]=(unsigned short)val; break;
      case 6 : if(num<a7int->nf) memcpy(&a7int->pF[num],&val,4); break;
      case 7 : if(num<a7int->nl) a7int->pL[num]=val; break;
      }
   }
fclose(f);
return 0;
}
#define FILEBLOCLEN 128

int target_prog_save(struct _a7int *a7int)
{
FILE *f;
unsigned char buff[FILEBLOCLEN];
unsigned long pos=0;
f=fopen(PROGFILENAME,"wb");
if(f==NULL) return -1;                        
while(pos<a7int->proglen)
	{
   unsigned long blen;
   blen=a7int->proglen-pos;
  if(blen>FILEBLOCLEN) blen=FILEBLOCLEN;
   memcpy(buff,&a7int->progmem[pos],blen);
	if(fwrite(buff,blen,1,f)!=1)
		{
  	 	fclose(f);
	   unlink(PROGFILENAME);
      return -1;
   	}
   pos+=blen;
   }
/*
if(fwrite(a7int->progmem,a7int->proglen,1,f)!=1)
	{
   fclose(f);
   unlink(PROGFILENAME);
   return -1;
   }
*/
fclose(f);
return 0;
}


int target_prog_load(struct _a7int *a7int)
{
FILE *f;
unsigned proglen;
unsigned char *progmem;
unsigned char buff[FILEBLOCLEN];
unsigned long pos=0;
f=fopen(PROGFILENAME,"rb");
if(f==NULL) return -1;
proglen=filel(f);
progmem=(unsigned char *)malloc(proglen);
if(progmem==NULL)
	{
   fclose(f);
   return -2;
   }
if(a7int->progmem) free((void *)a7int->progmem);
a7int->progmem=progmem;
a7int->proglen=proglen;
while(pos<proglen)
	{
   unsigned long blen;
   blen=proglen-pos;
if(blen>FILEBLOCLEN) blen=FILEBLOCLEN;
	if(fread(buff,blen,1,f)!=1)
		{
  	 	fclose(f);
      return -3;
   	}
   memcpy(&a7int->progmem[pos],buff,blen);
   pos+=blen;
   }
/*
if(fread(a7int->progmem,a7int->proglen,1,f)!=1)
	{
   fclose(f);
   return -2;
   }
*/
fclose(f);
return 0;
}

char webdir[256]="\\ahtml\\";

// Must return the path for downloadable files (HTML directory for beck tiny web server)
char* target_getfiledirectory(void)
{
return webdir;
}

char webpassword[64]="password";

// Must return the web password or "" if no password
char* target_getwebpassword(void)
{
return webpassword;
}


// Must reset SCADA	(after SCADA page reload)
int target_restartscada(void)
{
return 0;
}

// Must delete SCADA files (before SCADA page reload)
int target_deletescadafiles(void)
{
/*  
struct ffblk f;
char search[512];
int done;
sprintf(search,"%s*.*",target_getfiledirectory());
memset(&f,0,sizeof(f));
done=findfirst(search,&f,0);
while(!done)
	{
	if(!(f.ff_attrib&FA_DIREC))
		{
		char name[_MAX_PATH];
		sprintf(name,"%s%s",target_getfiledirectory(),f.ff_name);
		unlink(name);
		}
	done=findnext(&f);
	}
*/
return 0;
}


void target_aou(struct _a7int *a7int,unsigned long num,int len)
{
/*  
if(len==0)
	{
	outportb(num,(unsigned char)a7int->ac16);
   }
else
	{
	outport(num,a7int->ac16);
   }
*/
}

void target_ain(struct _a7int *a7int,unsigned long num,int len)
{
/*  
if(len==0)
	{
	a7int->ac16=inportb(num);
   }
else
	{
	a7int->ac16=inport(num);
   }
*/
}


void target_fun(struct _a7int *a7int,unsigned long num)
{
 /*
// Function 0: call 8086 interrupt, only ax,bx,cx and dx are modified
// call 8086 interrupt, a7int->ac16 give first word number packet
// packet is : 0=interrupt number, 1=ax (in), 2=bx (in), 3=cx (in), 4=dx (in), 5=ax (out),6=bx (out), 7=cx (out), 8=dx (out), 9=flags (out)
if(num==0)
	{
	union REGS inregs;
	union REGS outregs;
   unsigned short packetadr;
   unsigned short *pw;
   packetadr=a7int->ac16;
   if(packetadr>a7int->nm-10)
      {
      a7int->ac16=(unsigned short)-100;
   	return; // packet outside of words memory
   	}
   pw=&a7int->pM[packetadr];
   memset(&outregs,0,sizeof(outregs));
   memset(&inregs,0,sizeof(inregs));
   inregs.x.ax=pw[1];
   inregs.x.bx=pw[2];
   inregs.x.cx=pw[3];
   inregs.x.dx=pw[4];
	int86(pw[0],&inregs,&outregs);
   //if(pw[1]!=0x300) printf("call %4.4x %4.4x %4.4x %4.4x %4.4x R: %4.4x %4.4x %4.4x %4.4x %4.4x\n",pw[0],pw[1],pw[2],pw[3],pw[4],pw[5],pw[6],pw[7],pw[8],pw[9]);
	pw[5]=outregs.x.ax;
	pw[6]=outregs.x.bx;
	pw[7]=outregs.x.cx;
	pw[8]=outregs.x.dx;
   pw[9]=outregs.x.flags;
	}
else
	{
   if(num==1)
   	{
      // Function 1: load or save data to file (file name is
		// a7int->ac16 give first word number packet
		// packet is : 0= 0 for read, !=0 for write (in), 1=file name, file will be dataXXXXX.dat XXXXX is the dec value (in),2=first word number (in), 3=number of word to read or write (in), 4=number of word read or written (out)
   	unsigned short packetadr;
   	unsigned short *pw;
   	packetadr=a7int->ac16;
   	if(packetadr>a7int->nm-5)
      	{
      	a7int->ac16=(unsigned short)-100;
  	 		return; // packet outside of words memory
  	 		}
	   pw=&a7int->pM[packetadr];
      if(pw[2]+pw[3]>a7int->nm)
      	{
      	a7int->ac16=(unsigned short)-101;
  	 		return; // word buffer outside of words memory
         }
      //if(pw[0]==0)
      	{
         char filename[16];
         FILE *f;
         sprintf(filename,"data%5.5u.dat",pw[1]);
         f=fopen(filename,pw[0]==0?"rb":"wb");
         if(f==NULL)
         	{
            a7int->ac16=-1; // error while opening file for reading
            }
         else
         	{
            if(pw[0]==0)
            	{
            	pw[4]=fread(&a7int->pM[pw[2]],2,pw[3],f);
            	}
            else
            	{
            	pw[4]=fwrite(&a7int->pM[pw[2]],2,pw[3],f);
               }
           	fclose(f);
            a7int->ac16=0; // ok
            }
         }
      }
   a7int->ac16=(unsigned short)-1; // unknow function number
   }
*/
}

//
// Main
//

#define NI 128
#define NO 128      
#define NB 10000
#define NT 256
#define NC 10000
#define NM 10000
#define NF 10000
#define NL 10000


// Variables
unsigned char i[NI];
unsigned char o[NO];
unsigned char b[NB];
unsigned char t[NT*(sizeof(unsigned char)+sizeof(unsigned long)+sizeof(unsigned long))];
unsigned short c[NC];
unsigned short m[NM];
float f[NF];
unsigned long l[NL];

struct _a7int a7int;


// Variable memory and interpretor structure initialization
int init(void)
{
memset(&a7int,0,sizeof(a7int));
a7int.ni=NI;
a7int.no=NO;
a7int.nb=NB;
a7int.nt=NT;
a7int.nc=NC;
a7int.nm=NM;
a7int.nf=NF;
a7int.nl=NL;
a7int.pI=i;
a7int.pO=o;
a7int.pB=b;
a7int.pT=t;
a7int.pC=c;
a7int.pM=m;
a7int.pF=f;
a7int.pL=l;
a7int.init=1;
a7int.progmem=NULL;
return 0;
}

// Execute the program one time
void cycle(void)
{
if(a7int.init)
	{
	automgenintinit(&a7int);
	a7int.init=0;
	}
if((a7int.run||a7int.step))
	{
	automgenintrun(&a7int);
	if(a7int.pB[SYSTEM_BIT_EMERGENCY_STOP]&TRUEFORBOOL)
		{ // Emergency stop stops the program
		a7int.run=0;
		}
	a7int.step=0;
	}
// Process system variables
automgenintprocesssysvar(&a7int);
}

void uninit(void)
{
}

int strnicmp(const char *s1, const char *s2, size_t len)
{
        /* Yes, Virginia, it had better be unsigned */
        unsigned char c1, c2;

        if (!len)
                return 0;

        do {
                c1 = *s1++;
                c2 = *s2++;
                if (!c1 || !c2)
                        break;
                if (c1 == c2)
                        continue;
                c1 = tolower(c1);
                c2 = tolower(c2);
                if (c1 != c2)
                        break;
        } while (--len);
        return (int)c1 - (int)c2;
}

unsigned short webport=80;

//void __interrupt(__*myit)(void)=(void __interrupt(__*)(void))&a7int;

// Command line, usage:
// -COM=n : handle AUTOMGEN communication on COMn (by default handle comunication on IP
// -SLAVE=s : define target slave number (by default 1)
// -BAUD=b : define com baudrate (by default 115200) only valid for serial communication
// -PARITY=p : define com parity (E, O, N, S or M by default N) only valid for serial communication
// -STOPBIT=s : define target slave number (by default 115200) only valid for serial communication
// -IPPORT=p : handle AUTOMGEN ip communication on port p (by default 5000)
// -HTTPP=h : handle HTTP server on port h, (by default 80), if h=0, disable http server
// -WEBPW=pw : define pw as password for web server (by default password is "password")
// -WEBDIR=dir : define dir as root directory for web server files
int main(int argc,char *argv[])
{
int count=0;
for(count=1;count<argc;count++)
	{
	/*  
	if(strnicmp(argv[count],"-COM=",5)==0)
		{
		_com=atoi(&argv[count][5]);
		}
	if(strnicmp(argv[count],"-BAUD=",6)==0)
		{
		_baudrate=atol(&argv[count][6]);
		}
	if(strnicmp(argv[count],"-PARITY=",7)==0)
		{
		_parity=argv[count][7];
		}
	if(strnicmp(argv[count],"-STOPBIT=",9)==0)
		{
		_stopbit=atol(&argv[count][9]);
		}
	if(strnicmp(argv[count],"-SLAVE=",7)==0)
		{
		slavenumber=(unsigned char)atoi(&argv[count][7]);
		}
	*/
	if(strnicmp(argv[count],"-IPPORT=",8)==0)
		{
		_tcpipport=(unsigned short)atoi(&argv[count][8]);
		}
	if(strnicmp(argv[count],"-HTTPP=",7)==0)
		{
		webport=(unsigned short)atoi(&argv[count][7]);
		}
	if(strnicmp(argv[count],"-WEBPW=",7)==0)
		{
		strcpy(webpassword,&argv[count][7]);
		}
	if(strnicmp(argv[count],"-WEBPDIR=",9)==0)
		{
		strcpy(webdir,&argv[count][9]);
		}
	}
printf("AUTOMGEN RUNTIME FOR LINUX V%u.%3.3u\n",VERSION,RELEASE);
if(init()<0) // Interpretor initialization
	{
	printf("AUTOMGEN INTERPRETOR INITIALIZATION FAILED\n");
	exit(-1);
	};
if(initcom()<0) // Communication setup
	{
	printf("AUTOMGEN COMMUNICATION INITIALIZATION FAILED\n");
	exit(-2);
	}
if(initio()<0) // I/O initialization
	{
	printf("AUTOMGEN I/O INITIALIZATION FAILED\n");
	exit(-3);
	}
printf("AUTOMGEN RT FOR LINUX LOADED\n");
/*
if(webport!=0)
	{
	// initializing web server (port 81, because builtin BECK web server already uses port 80)
	if(tws_srvinit(webport)==0)
		{
		printf("AUTOMGEN WEB SERVER INITIALIZED\n");
		}
	else
		{
		printf("AUTOMGEN WEB SERVER INITILIZATION FAILED\n");
		}
	}
*/
// load last prog if exists
if(target_prog_exist())
	{
   int ret;
   printf("%s FOUND, LOADING... ",PROGFILENAME);
   ret=target_prog_load(&a7int);
   if(ret==0)
   	{
	   printf("%s LOADED, SWITCH TO RUN MODE\n",PROGFILENAME);
		if(target_prd_exist())
  	 		{
   	   printf("PRD FILE EXISTS...");
  			if(target_prd_load(&a7int)==0)
  	 			{
		   	printf("%s LOADED\n",PRDFILENAME);
      		}
     	 else
      		{
         	printf("ERROR LOAFING %s\n",PRDFILENAME);
         	}
      	}
      }
   else
   	{
      printf("ERROR %d WHILE LOADING FILE\n",ret);
      }
   a7int.run=1;
   }
do
	{
	if((count%10000==0))printf("%c - %c - %4.4X - %u\n",a7int.run?'R':'S',(a7int.pB[SYSTEM_BIT_EMERGENCY_STOP]&TRUEFORBOOL)?'E':' ',a7int.pM[SYSTEM_WORD_ERROR_NUMBER],count++);
	// Process the communication
	processcom(&a7int);
	// Process inputs
	// Reset I/O pos
	a7int.io_i_pos=0;
	a7int.io_o_pos=0;
	a7int.io_m_pos=200;
	readi(&a7int);
	// Ex�cute the program one time
	cycle();
	// Process outputs
	writeo(&a7int);
	//tws_process(); // http server processing
	}
while(1);
return 0;
}

/*
tws_srvuninit();
uninitio();	// I/O stop
uninitcom(); // Communication STOP
uninit(); // Interpretor stop
*/

